local addonName, addon = ...

_G[addonName] = addon


local EasyAddFriend = CreateFrame("Frame","EasyAddFriendFrame")
EasyAddFriend:SetScript("OnEvent", function() hooksecurefunc("UnitPopup_ShowMenu", EasyAddFriendCheck) EasyAddFriendSlash() end)
EasyAddFriend:RegisterEvent("PLAYER_LOGIN")

local PopupUnits = {"PARTY", "PLAYER", "RAID_PLAYER", "RAID", "FRIEND", "TEAM", "CHAT_ROSTER", "TARGET", "FOCUS"}

local AddFriendButtonInfo = {
	text = "Add Friend",
	value = "ADD_FRIEND",
	func = function() AddFriend(UIDROPDOWNMENU_OPEN_MENU.name) end,
	notCheckable = 1,
}

local CancelButtonInfo = {
	text = "Cancel",
	value = "CANCEL",
	notCheckable = 1
}

function EasyAddFriendSlash()
	SLASH_EASYADDFRIEND1 = "/add";
	SlashCmdList["EASYADDFRIEND"] = function(msg) if #msg == 0 then DEFAULT_CHAT_FRAME:AddMessage("EasyAddFriend: Use '/add' followed by a character's name to add them to your friends list.") else AddFriend(msg) end end
end

function EasyAddFriendCheck()		
	local PossibleButton = getglobal("DropDownList1Button"..(DropDownList1.numButtons)-1)
	if PossibleButton["value"] ~= "ADD_FRIEND" then						-- is there not already an add friend button on it?
						
		local GoodUnit = false
		for i=1, #PopupUnits do	
			if OPEN_DROPDOWNMENUS[1]["which"] == PopupUnits[i] then	
				GoodUnit = true
			end
		end
																	-- make sure the unit isn't an npc or enemy player
		if UIDROPDOWNMENU_OPEN_MENU["unit"] == "target" and ((not UnitIsPlayer("target")) or (not UnitIsFriend("player", "target"))) then
			GoodUnit = false
		end
		
		if GoodUnit then	-- is the unit of the popup one that we want to use? (e.g. not vehicles, npcs, or enemy players)
			local IsAlreadyFriend = false
			for z=1, GetNumFriends() do
				if GetFriendInfo(z) == UIDROPDOWNMENU_OPEN_MENU["name"] or UIDROPDOWNMENU_OPEN_MENU["name"] == UnitName("player") then
					IsAlreadyFriend = true
				end
			end
			if not IsAlreadyFriend then				-- is this person not already your friend?
				CreateAddFriendButton()			-- Add the button
			end
		end
	end
end

function CreateAddFriendButton()
			
		-- we have decided to actually make the frame, we are going to place it above the "Cancel" button
		local CancelButtonFrame = getglobal("DropDownList1Button"..DropDownList1.numButtons)
		CancelButtonFrame:Hide() 									-- hide the "Cancel" button
		DropDownList1.numButtons = DropDownList1.numButtons - 1		-- make the DropDownMenu API think the "Cancel" button never existed
		UIDropDownMenu_AddButton(AddFriendButtonInfo)				-- create our "Add Friend" button, it gets put where the cancel button used to be
		UIDropDownMenu_AddButton(CancelButtonInfo)					-- create a new cancel button after our "Add Friend" button
	
end